## Script (Python) "apply_pume"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=REQUEST
##title=
##
# $Id: apply_pume.py 2168 2007-08-29 06:24:39Z henrik $
"""
process the Pume Application Form
"""
try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass

import DateTime
import logging
logger = logging.getLogger('Skins.apply_pume')

mtool = context.portal_membership
member = mtool.getAuthenticatedMember()

current = DateTime.DateTime()
pr = context.portal_registration
request = REQUEST

#type_name = 'StudentApplication'
#ti = context.portal_types[type_name]
#REQUEST.set('type_name',type_name)
create = "create" in request.keys()
apply_pume = "apply" in request.keys()
edit = "edit" in request.keys()
slip = "slip" in request.keys()
manage = "manage" in request.keys()
submitted = False
mode = request.get('mode','')
if not mode:
    if apply_pume or edit or manage:
        mode = "edit"
    else:
        mode = "create"
validate = create or edit or apply_pume

if manage:
    validate = False

lt = context.portal_layouts
reg_no = request.get('widget__reg_no','').upper()
if not reg_no:
    reg_no = request.form.get('reg_no','').upper()
pin = request.form.get('pin','')
object = {}
if reg_no:
    brains = context.applicants_catalog(reg_no = reg_no)
    if len(brains) == 1:
        for field in context.applicants_catalog.schema():
            object[field] = getattr(brains[0],field,None)
        if not object['passport']:
                object['passport'] = ''
        if object['status'] and 'submitted' in object['status']:
            submitted = True
        if not create and (pin != object['pin'] and not context.isSectionOfficer()):
            logger.info('%s/%s entered wrong pin %s' % (member,reg_no,pin))
            return request.RESPONSE.redirect("%s/srp_anonymous_view" % context.portal_url())
if slip:
    mode = "view_slip"
    logger.info('%s/%s views application slip' % (member,reg_no))

res,psm,ds = lt.renderLayout(layout_id= 'application',
                             schema_id= 'application',
                             layout_mode = mode,
                             context=context,
                             mapping=validate and REQUEST,
                             ob=object,
                             commit = False,
                            )

if slip:
    return context.apply_pume_slip(rendered = res,
                                   psm = "",
                                   #psm = "%s, %s" % (psm,ds),
                                   mode = mode,
                                   ds = ds,
                                  )

if psm == 'invalid':
    return context.apply_pume_form(rendered = res,
                                   psm = "Please correct your input!",
                                   #psm = "%s, %s" % (psm,ds),
                                   mode = mode,
                                   ds = ds,
                                  )
elif psm == '' and not manage:
    return context.apply_pume_form(rendered = res,
                                   psm = psm,
                                   ds = ds,
                                   mode = mode,
                                  )
elif psm == 'valid' or (psm == '' and manage):
    pass
data = {}
dm = ds.getDataModel()
for field in context.applicants_catalog.schema():
    if dm.has_key("%s" % field):
        data[field] = dm.get(field)
data['reg_no'] = reg_no



if apply_pume:
    if submitted:
        mode = "view"
        psm = "The form has already been submitted and you are not allowed to resubmit the data!"
        logger.info('%s/%s tried to resubmit application record' % (member,reg_no))
        res,psm_dummy,ds_dummy = lt.renderLayout(layout_id= 'application',
                                schema_id= 'application',
                                layout_mode = mode,
                                context=context,
                                mapping={},
                                ob=object,
                                commit = False,
                                )
    elif not request.has_key('confirm'):
        mode = "edit"
        psm = "Please confirm Passport Photograph!"
        logger.info('%s/%s tried to submit without ticking confirmation check box' % (member,reg_no))
    else:
        mode = "view"
        psm = "You successfully applied for PUME!"
        if object['status'] == 'edited':
            data['status'] = "submitted"
            data['application_date'] = current
            logger.info('%s/%s modified and submitted application record' % (member,reg_no))
        elif object['status'] == 'reset':
            data['status'] = 'resubmitted on %s' % DateTime.DateTime().strftime('%A, %B %d, %Y')
            logger.info('%s/%s modified and resubmitted application record' % (member,reg_no))
        object['status'] = data['status']
        context.applicants_catalog.modifyRecord(**data)

        res,psm_dummy,ds = lt.renderLayout(layout_id= 'application',
                                schema_id= 'application',
                                layout_mode = mode,
                                context=context,
                                mapping=validate and REQUEST,
                                ob=object,
                                commit = False,
                                )
elif create:
    if submitted:
        mode = "view"
        logger.info('%s/%s views application record' % (member,reg_no))
    else:
        mode = "edit"
        logger.info('%s/%s edits application record' % (member,reg_no))
    psm = ""
    #set_trace()
    object['pin'] = str(ds.get('pin'))
    res,psm,ds_dummy = lt.renderLayout(layout_id= 'application',
                                schema_id= 'application',
                                layout_mode = mode,
                                context=context,
                                mapping={},
                                ob=object,
                                commit = False,
                                )
elif edit:
    if submitted:
        mode = "view"
        psm = "The form has already been submitted and you are not allowed to modify the data!"
        logger.info('%s/%s tried to edit submitted application record' % (member,reg_no))
        res,psm_dummy,ds_dummy = lt.renderLayout(layout_id= 'application',
                                schema_id= 'application',
                                layout_mode = mode,
                                context=context,
                                mapping={},
                                ob=object,
                                commit = False,
                                )
    else:
        mode = "edit"
        psm = "Content changed!"
        data['status'] = "edited"
        context.applicants_catalog.modifyRecord(**data)
        logger.info('%s/%s modified application record' % (member,reg_no))

elif manage:
    if submitted:
        mode = "view"
        psm = "You are now assuming the applicant's role!"
        logger.info('%s/%s entered application record' % (member,reg_no))
        res,psm_dummy,ds_dummy = lt.renderLayout(layout_id= 'application',
                                schema_id= 'application',
                                layout_mode = mode,
                                context=context,
                                mapping={},
                                ob=object,
                                commit = False,
                                )
    else:
        mode = "edit"
        psm = "You are now assuming the applicant's role!"
        logger.info('%s/%s entered application record' % (member,reg_no))


try:
    passport_uploaded = bool(data['passport'])
except:
    passport_uploaded = False

return context.apply_pume_form(rendered = res,
                            psm = psm,
                            #psm = "%s, %s" % (psm,ds),
                            mode = mode,
                            show_submit = passport_uploaded,
                            ds = ds,
                            )


